/* $Id: Piano.java,v 1.6 2010/09/25 07:11:41 mit Exp $ */
/* Piano.java */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class Piano extends Applet implements AdjustmentListener 
{
    private Scrollbar scrX;
    final int L = 40;    // Ĺ
    int W;
    int H;
    int Spoint;
    DecimalFormat df1;

    public void init() {
	setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());
	df1 = new DecimalFormat("#0.0#");

        Panel p = new Panel();
        p.setLayout(new GridLayout(1,2,0,0));

        scrX = new Scrollbar(Scrollbar.HORIZONTAL,L/2,1,1,L);
	p.add(scrX);
	scrX.addAdjustmentListener(this);

        p.add(new Label(" : Striking Point"));

        add(p, "South");
    }
    public void start() {
	W = getSize().width;
	H = getSize().height;
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
        repaint();
    }
    //
    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
	int M = 100;   // ܿ
	int hh = (int)(H*2/3d);
	int dh = H/2;
	double dx = (double)W/L;
	double[] Sum = new double[L+1];

	Spoint = scrX.getValue(); // Ǹ

	g.setColor(Color.black);
	g.fillRect(0, 0, W, H);

	g.setColor(Color.red);
	g.drawString("Striking Point: 1/"+
		     dform(1.0/(Spoint/(double)L)), 10, 15); 

	int y0, y1;
	double yd;
	g.setColor(Color.cyan);
	for (int i = 1; i <= M; i++) {
	    y0 = (int)(hh-dh*yy(i, 0)); // ya
	    for (int x = 1; x <= L; x++) {
		yd = yy(i, x); // ya
		y1 = (int)(hh-dh*yd);
		Sum[x] += yd;

		g.drawLine((int)(dx*(x-1)), y0, (int)(dx*x), y1);
		y0 = y1;
	    }
	}

	double h0, v0, h1 = 0, v1 = 0;
	g.setColor(Color.green);
	for (int j = 0; j <= L; j++) {
	    h0 = dx*j;
	    v0 = hh-dh*Sum[j];
	    if (j == 0) {
		h1 = h0;
		v1 = v0;
		continue;
	    }
	    g.drawLine((int)h1, (int)v1, (int)h0, (int)v0);
	    h1 = h0;
	    v1 = v0;
	}
    }

    public double yy(int m, int x) { // y
	double mp = m * Math.PI;
	return (1/mp * Math.sin(mp*(double)Spoint/L) *
		Math.sin(mp*(double)x/L));
    }        // "sin mt"ϻִؿ(?)ΰپά
}